<template>
  <router-link
    :id="`fact-${id}`"
    :to="`/facts/${id}`"
    :class="['teaser', `teaser--$`]"
  >
    <cdx-icon :icon="cdxIconPlay" />
    <span class="teaser__text">
      {{ fact }}
    </span>
  </router-link>
</template>

<script lang="ts" setup>
import { cdxIconPlay } from '@wikimedia/codex-icons';
import { CdxIcon } from '@wikimedia/codex';
import { inject } from 'vue';
import { FactsKey } from '../constants';

const props = defineProps({
  id: { type: Number, required: true },
});

const facts = inject(FactsKey)!;
const { fact } = facts[props.id];
</script>

<style lang="less">
.teaser {
  flex-grow: 0;
  flex-shrink: 0;
  aspect-ratio: 9 / 16;
  padding: 2rem;
  background-color: blue;
  object-fit: contain;
  height: 60dvh;
  border-radius: 10px;

  display: flex;
  flex-direction: column;
  justify-content: space-between;

  text-decoration: none;
  color: white;

  @media (min-width: 1440px) {
    height: 65dvh;
  }

  &--red {
    background-color: var(--brand-red);
  }

  &--pink {
    background-color: var(--brand-pink);
  }

  &--orange {
    background-color: var(--brand-orange);
  }

  &--yellow {
    background-color: var(--brand-yellow);
    color: initial;
  }

  &--purple {
    background-color: var(--brand-purple);
  }

  &--dark-green {
    background-color: var(--brand-dark-green);
  }

  &--blue {
    background-color: var(--brand-blue);
  }

  &--bright-blue {
    background-color: var(--brand-bright-blue);
  }

  &--bright-yellow {
    background-color: var(--brand-bright-yellow);
    color: initial;
  }

  &--green {
    background-color: var(--brand-green);
  }

  &--bright-green {
    background-color: var(--brand-bright-green);
  }

  .cdx-icon {
    color: white;
    align-self: flex-end;
    @media (min-width: 640px) {
      width: 2rem;
      height: 2rem;
    }
  }
}

.teaser__text {
  font-size: 1.25rem;

  @media (min-width: 480px) {
    font-size: 1.5rem;
  }

  @media (min-width: 640px) {
    font-size: 1.75rem;
  }

  @media (min-width: 960px) {
    font-size: 2.25rem;
  }

  @media (min-width: 1440px) {
    font-size: 2.5rem;
  }
}
</style>
